/*
ChrispyChars AI
	by Lach

beta
*/

local DAB_ENTER_DELAY = 4*TICRATE/3
local DAB_EXIT_DELAY = TICRATE
local CROUCH_DELAY = TICRATE/8

local function valid(mo)
	return mo and mo.valid
end

addHook("BotTiccmd", function(player2, cmd2)
	local player1 = players[0]
	local cmd1 = player1.cmd
	local mo1 = player1.mo
	local mo2 = player2.mo
	local chrispy1 = player1.chrispy
	local chrispy2 = player2.chrispy
	
	if player1.exiting == 1
	or not (valid(mo1) and valid(mo2))
	or not (chrispy1 and chrispy2)
		return
	end
	
	if player2.powers[pw_carry] == CR_DUSTDEVIL
	or player2.powers[pw_carry] == CR_PLAYER
		return true
	end
	
	local bot = chrispy2.bot
	
	if not bot
		bot = {}
		bot.flags = 0
		bot.dabdelay = 0
		bot.crouchdelay = 0
		chrispy2.bot = bot
	end
	
	if P_IsObjectOnGround(mo2)
		bot.flags = $ & ~CF_FLIPPED
	end
	
	// looking up/down
	
	if twodlevel or mo2.flags2 & MF2_TWOD
	or P_AproxDistance(mo1.x - mo2.x, mo1.y - mo2.y) < 32*mo2.scale
		cmd2.aiming = cmd1.aiming
	end
	
	// Fly with momentum flip
	
	if chrispy1.flags & CF_FLIPPED
	and player2.charability == CA_FLY
	and player2.pflags & (PF_JUMPED|PF_THOKKED) == PF_JUMPED
	and not (mo2.eflags & MFE_UNDERWATER)
	and chrispy2.time & 1
		cmd2.buttons = $ | BT_JUMP // mash jump!
		bot.flags = $ | CF_FLIPPED
	end
	
	// Drop dash
	
	if chrispy1.flags & CF_DROPDASHCHARGE
	and player2.pflags & PF_JUMPED
		bot.flags = $ | CF_DROPDASHCHARGE
	end
	
	if bot.flags & CF_DROPDASHCHARGE
		if player2.pflags & PF_JUMPED
			cmd2.buttons = $ | BT_USE
		end
		if not (chrispy1.flags & CF_DROPDASHCHARGE or player1.pflags & PF_SPINNING)
			bot.flags = $ & ~CF_DROPDASHCHARGE
		end
	end
	
	// Crouch
	
	if (chrispy1.flags & CF_CROUCHING) ~= (chrispy2.flags & CF_CROUCHING)
	and (player2.panim == PA_IDLE or mo2.state == S_PLAY_LOOK)
		bot.crouchdelay = $ + 1
		if bot.crouchdelay > CROUCH_DELAY
		and chrispy2.time & 1
			cmd2.buttons = $ | CC_DEFAULTBUTTONS.crouch
		end
	else
		bot.crouchdelay = 0
	end
	
	// Dab (yeah sorry this block is a bit barbaric)
	
	if mo2.state == S_CHRISPY_DAB // if dabbing, undab after a short period of time
		if mo1.state == S_CHRISPY_DAB
			bot.dabdelay = 0
			cmd2.forwardmove = 0 // don't move!
			cmd2.sidemove = 0
			return true
		else
			bot.dabdelay = $ + 1
			if bot.dabdelay > DAB_EXIT_DELAY
			and chrispy2.time & 1
				cmd2.buttons = $ | CC_DEFAULTBUTTONS.dab
			end
		end
	elseif mo1.state == S_CHRISPY_DAB // if not dabbing, but player 1 is dabbing, try to dab
		if mo2.state == S_PLAY_LOOK // if neck is enabled, wait a little while to react to player 1 first
		and player2.emotion_enabled ~= false
			if mo2.neck and mo2.neck.target == mo1
				bot.dabdelay = $ + 1
				if bot.dabdelay > DAB_ENTER_DELAY
				and mo2.state ~= S_CHRISPY_DAB
					cmd2.buttons = $ | CC_DEFAULTBUTTONS.dab
				end
			end
		elseif mo2.state ~= S_CHRISPY_DAB
		and chrispy2.time & 1 // MASH THE DAB BUTTON
			cmd2.buttons = $ | CC_DEFAULTBUTTONS.dab
		end
	elseif bot.dabdelay
		bot.dabdelay = 0
	end
end)

addHook("AbilitySpecial", function(player)
	local chrispy = player.chrispy
	local bot = chrispy and chrispy.bot
	
	if player.pflags & PF_THOKKED
	or not (bot and bot.flags & CF_FLIPPED)
		return
	end
	
	bot.flags = $ & ~CF_FLIPPED
	player.pflags = $ | PF_CANCARRY
end)