rawset(_G,"Pointy_Battle",{})

local rollstate = S_CHRISPY_DROPDASH

local costrings = 5

-- local bouncesfx = sfx_s3k5f
local bouncesfx = sfx_bnce2

local cooldown1 = TICRATE
local cooldown2 = TICRATE*3/2

local state_superspinjump = 1
local state_groundpound_fall = 2
local state_groundpound_rise = 3

local jumpthrust = 8*FRACUNIT
local forwardthrust = 80*FRACUNIT
local jumptics = 15

local pound_downthrust = 16*FRACUNIT
local pound_forwardthrust = 24
local reboundthrust = 12

local jumpfriction = FRACUNIT*90/100
local poundfriction = FRACUNIT

Pointy_Battle.Priority = function(player)
	local B = CBW_Battle
	if player.actionstate == state_superspinjump then
		B.SetPriority(player,2,2,nil,2,2,"super spin attack")
	elseif player.actionstate == state_groundpound_rise then
		B.SetPriority(player,1,2,nil,1,2,"rising spin bounce")
	elseif player.actionstate == state_groundpound_fall then
		B.SetPriority(player,2,2,nil,2,2,"super spin bounce")
	end
end

Pointy_Battle.Special = function(mo,doaction)
	local B = CBW_Battle
	local player = mo.player
	player.actionrings = costrings
	if P_IsObjectOnGround(mo) then
		player.actiontext = "Super Spin Attack"
	else
		player.actiontext = "Super Spin Bounce"
	end
	
	if player.actionstate != 0 then player.canguard = false end
	local water = B.WaterFactor(mo)
	local thrust
	local thrust2
	local jumpflags = (player.pflags|PF_JUMPED|PF_THOKKED)&~(PF_STARTJUMP|PF_NOJUMPDAMAGE|PF_GLIDING|PF_BOUNCING|PF_SPINNING)
	//Neutral
	if player.actionstate == 0
		if doaction == 1 then
			B.PayRings(player)
			//Do high jump
			if P_IsObjectOnGround(mo) then
				player.actionstate = state_superspinjump
				player.actiontime = 0
				thrust = FixedMul(jumpthrust,player.jumpfactor)
				thrust2 = FixedMul(forwardthrust,mo.scale)
				P_InstaThrust(mo,mo.angle,thrust2)
				P_SetObjectMomZ(mo,thrust,true) //Inherit platform momentum
				S_StartSound(mo,sfx_s3k3c)
				S_StartSound(mo,sfx_kc5b)
				player.pflags = jumpflags
				mo.state = rollstate
				player.secondjump = 0
				player.canguard = false
				B.ApplyCooldown(player,cooldown1)
			else//Do ground pound
				B.ApplyCooldown(player,cooldown2)
				thrust = -pound_downthrust/water
				thrust2 = pound_forwardthrust*mo.scale/water
				player.actionstate = state_groundpound_fall
				P_SetObjectMomZ(mo,thrust,false)
				P_InstaThrust(mo,mo.angle,thrust2)
				S_StartSound(mo,sfx_zoom)
				mo.state = rollstate
				player.pflags = jumpflags
				player.secondjump = 0
			end
		end
	return end
	
	//Ground pound fall
	if player.actionstate == state_groundpound_fall 
		local endgroundpound = false
		if mo.momz*P_MobjFlip(mo) > 0 then //If we're moving upward, then something must have interrupted us.
			endgroundpound = true
		else
			if P_IsObjectOnGround(mo) then //We have hit a surface
				player.actionstate = state_groundpound_rise
				thrust = reboundthrust*FRACUNIT/water
				P_SetObjectMomZ(mo,thrust,true) //Inherit platform momentum
				S_StartSound(mo,bouncesfx)
				mo.state = rollstate
				player.pflags = $|PF_JUMPED|PF_THOKKED
				local obj = MT_DUST
				//Create blast
				for n = 0, 23
					local p = P_SPMAngle(mo,MT_DUST,mo.angle+n*ANG15,0)
					if p and p.valid then
						p.momz = mo.scale*P_MobjFlip(mo)*2/water
						p.fuse = TICRATE/3
						P_InstaThrust(p,p.angle,player.actiontime>>1)
					end
				end
			else
				player.actiontime = abs(mo.momz)
			end
		end
		if endgroundpound //End ground pound state
			player.actionstate = 0
			mo.state = S_PLAY_FALL
			if player.pflags&PF_JUMPED then
				player.pflags = $|PF_STARTJUMP|PF_NOJUMPDAMAGE
			end
			player.pflags = $&~(PF_SPINNING|PF_THOKKED)
		end
	end
	
	//Rebound state
	if player.actionstate == state_groundpound_rise and mo.momz*P_MobjFlip(mo) <= 0
		player.actionstate = 0
		mo.state = S_PLAY_FALL
		if player.pflags&PF_JUMPED then
			player.pflags = $|PF_STARTJUMP|PF_NOJUMPDAMAGE
		end
		player.pflags = $&~(PF_SPINNING|PF_THOKKED)
	end
	
	//SuperSpinJump state
	if player.actionstate == state_superspinjump 
		player.actiontime = $+1
		B.ControlThrust(mo,jumpfriction,nil,jumpfriction,nil)
		//Go into fall frames after end-rising
		if player.actiontime > jumptics then 
			mo.state = S_PLAY_FALL
			player.pflags = ($&~PF_THOKKED)|PF_NOJUMPDAMAGE
			player.actionstate = 0
		end
		if P_IsObjectOnGround(mo) then
			player.actionstate = 0
		end
	end
	
	//Extraneous
	if player.actionstate and player.pflags&PF_JUMPED then
		local ghost = P_SpawnGhostMobj(player.mo)
-- 		ghost.colorized = true
		ghost.state = S_THOK
		P_TeleportMove(ghost,ghost.x,ghost.y,ghost.z-ghost.scale*4)
		ghost.destscale = ghost.scale/10
		player.pflags = $|PF_THOKKED
		player.drawangle = mo.angle
	end
end