/*
Peelout Ghosts
	by Lach

beta
*/

// why do I have a separate script for this?
// this was supposed to go in POINTY-SONIC.lua, but I needed to use a PostThinkFrame that runs after Fluffy Tails' script, and it doesn't belong in there

local SKIN = "pointy"
local GHOST_COLOR = SKINCOLOR_ICY // color to colorize the peelout ghost objects when player is their prefcolor

local queue = {}

rawset(_G, "CC_SpawnGhosts", function(mo)
	local rets = {}
	local ghost = P_SpawnGhostMobj(mo)
	table.insert(rets, ghost)
	table.insert(rets, ghost.tracer)
	if mo.fluffytails
		for _, tail in ipairs(mo.fluffytails.tails)
			table.insert(rets, P_SpawnGhostMobj(tail))
		end
	end
	return unpack(rets)
end)

local function DoPeeloutGhost(player, refobj, prevpos, ghost, ...)
	local mo = player.mo
	ghost.tics = 2
	ghost.colorized = true
	if mo == refobj and mo.color == player.skincolor and player.skincolor == skins[SKIN].prefcolor
		ghost.color = GHOST_COLOR
	end
	P_TeleportMove(ghost,
		ghost.x + prevpos[1] - refobj.x,
		ghost.y + prevpos[2] - refobj.y,
		ghost.z + prevpos[3] - refobj.z)
	
	for _, tracer in ipairs({...})
		tracer.fuse = ghost.fuse
		tracer.tics = ghost.tics
		tracer.color = ghost.color
		tracer.colorized = ghost.colorized
		P_TeleportMove(tracer,
			tracer.x + prevpos[1] - refobj.x,
			tracer.y + prevpos[2] - refobj.y,
			tracer.z + prevpos[3] - refobj.z)
	end
end

rawset(_G, "CC_QueueGhost", function(player, prevpos, refobj)
	table.insert(queue, {
		player = player,
		prevpos = prevpos,
		refobj = refobj
	})
end)

addHook("PostThinkFrame", do
	if #queue
		for _, item in ipairs(queue)
			DoPeeloutGhost(item.player, item.refobj, item.prevpos, CC_SpawnGhosts(item.player.mo))
		end
		queue = {}
	end
end)