/*
ChrispyChars commands & menu
	by Lach

beta
*/

/*
I moved functions around a ton while adding to this since I had to solve netgame
errors and allow certain functions to access different variables
Also a lot of the stuff is duplicated from the other scripts since mobjs
obviously aren't used in HUD functions
So everything's a bit disorganized, sorry!
*/

local function Boolean(arg)
	local num = tonumber(arg)
	if num ~= nil
		return num > 0
	end
	
	if arg == "on"
	or arg == "yes"
	or arg == "true"
		return true
	elseif arg == "off"
	or arg == "no"
	or arg == "false"
		return false
	end
end

local function GetEnabledString(val)
	return val and "enabled." or "disabled."
end

local function CommandToggle(player, arg, var, name, desc)
	local val
	if arg
		arg = $:lower()
		val = Boolean(arg)
		if val ~= nil
			player[var] = val
			if not player.cc_nosave
				CONS_Printf(splitscreen and consoleplayer or player, name.." "..GetEnabledString(player[var]))
				if CC_SaveConfiguration
					CC_SaveConfiguration(player)
				end
			end
			return
		end
	end
	
	CONS_Printf(splitscreen and consoleplayer or player, desc)
end

local function ToggleFlicker(player, arg)
	CommandToggle(player, arg, "cc_flickerenabled", "Flicker", "Enables/disables translucency effects during roll and certain tail animations.")
end

COM_AddCommand("flicker2", ToggleFlicker, 2)
COM_AddCommand("flicker", ToggleFlicker)

local function ToggleGauge(player, arg)
	CommandToggle(player, arg, "cc_gaugeenabled", "Flightometer", "Enables/disables Fluffy Tails' flight gauge.")
end

COM_AddCommand("gauge2", ToggleGauge, 2) // TODO: make these cvars
COM_AddCommand("gauge", ToggleGauge)

local function ToggleHater(player, arg)
	CommandToggle(player, arg, "cc_haterenabled", "Hater mode", "Enables/disables being a hater instead of dabbing.")
end

COM_AddCommand("hater2", ToggleHater, 2)
COM_AddCommand("hater", ToggleHater)

local function ToggleThatsTails(player, arg)
	CommandToggle(player, arg, "cc_thatstailsenabled", "Hedgefox mode", "Enables/disables hedgefox mode.")
end

COM_AddCommand("thatstails2", ToggleThatsTails, 2)
COM_AddCommand("thatstails", ToggleThatsTails)

local NOBUTTON = 1 << 29
local BUTTONNAMES = {
	[BT_WEAPONNEXT] = "Next Weapon",
	[BT_WEAPONPREV] = "Previous Weapon",
	[BT_ATTACK] = "Ring Toss",
	[BT_TOSSFLAG] = "Toss Flag",
	[BT_FIRENORMAL] = "Ring Toss Normal",
	[BT_CUSTOM1] = "Custom 1",
	[BT_CUSTOM2] = "Custom 2",
	[BT_CUSTOM3] = "Custom 3",
	[NOBUTTON] = "No button"
}

rawset(_G, "CC_DEFAULTBUTTONS",
{
	dab = BT_TOSSFLAG,
	crouch = BT_CUSTOM1,
	dance = BT_CUSTOM2, // don't change the assignment for dance - CC_DANCES.lua can be included standalone in other addons, where it assumes Custom 2 is the default
	menu = BT_CUSTOM3
})

local function CheckButtonMap(player)
	if not player.cc_buttonmap
		player.cc_buttonmap = {}
		for i, butt in pairs(CC_DEFAULTBUTTONS)
			player.cc_buttonmap[i] = butt
		end
	end
end

local function ReassignButton(action, player, ...)
	local arg = table.concat({...}, " ")
	
	if arg
		local num = tonumber(arg)
		
		// check whether argument matches any of the button values
		if num and BUTTONNAMES[num]
			// do nothing, we're set up
		else
			num = 0
			arg = arg:upper()
		
			// check whether the argument matches any of the button names
			for i, name in pairs(BUTTONNAMES)
				name = name:upper()
				if arg == name
				or arg == name:gsub(" ", "")
					num = i
					break
				end
			end
			
			// check whether the argument matches any of the button constants
			if not num
				if arg:sub(1, 3) ~= "BT_"
					arg = "BT_"..arg
				end
				
				num = _G[arg]
				
				if not BUTTONNAMES[num]
					num = 0
				end
			end
			
			// use "none" as an alias for "no button"
			if not num
			and arg == "NONE"
				num = NOBUTTON
			end
		end
		
		if num // valid button, so let's reassign
			// generate buttonmap if there isn't one already
			CheckButtonMap(player)
			
			// check to see if another action is already mapped to the new button; if so, swap the buttons
			local message = ""
			
			if not player.cc_nosave
				for i, butt in pairs(player.cc_buttonmap)
					if butt == num
					and i ~= action
						player.cc_buttonmap[i] = player.cc_buttonmap[action]
						message = "\n"..BUTTONNAMES[player.cc_buttonmap[i]].." now activates "..i.."."
						break
					end
				end
				message = BUTTONNAMES[num].." now activates "..action.."."..$
			end
			
			player.cc_buttonmap[action] = num
			
			if not player.cc_nosave
				CONS_Printf(splitscreen and consoleplayer or player, message)
				if CC_SaveConfiguration
					CC_SaveConfiguration(player)
				end
			end
			
			return
		end
	end
	
	CONS_Printf(splitscreen and consoleplayer or player, "Changes which button activates "..action..".")
end

local function DabButton(player, ...)
	ReassignButton("dab", player, ...)
end

COM_AddCommand("dabbutton2", DabButton, 2)
COM_AddCommand("dabbutton", DabButton)

local function CrouchButton(player, ...)
	ReassignButton("crouch", player, ...)
end

COM_AddCommand("crouchbutton2", CrouchButton, 2)
COM_AddCommand("crouchbutton", CrouchButton)

local function DanceButton(player, ...)
	ReassignButton("dance", player, ...)
end

COM_AddCommand("dancebutton2", DanceButton, 2)
COM_AddCommand("dancebutton", DanceButton)

local function MenuButton(player, ...)
	ReassignButton("menu", player, ...)
end

COM_AddCommand("menubutton2", MenuButton, 2)
COM_AddCommand("menubutton", MenuButton)

rawset(_G, "cv_bass", CV_RegisterVar(
	{"bass", "On", CV_NOINIT|CV_CALL, CV_OnOff, function()
		if not consoleplayer.cc_nosave
			print("Dab bass "..GetEnabledString(cv_bass.value))
			if CC_SaveConfiguration
				CC_SaveConfiguration(consoleplayer)
			end
		end
	end}
))
rawset(_G, "cv_steps", CV_RegisterVar(
	{"steps", "On", CV_NOINIT|CV_CALL, CV_OnOff, function()
		if not consoleplayer.cc_nosave
			print("Footsteps "..GetEnabledString(cv_steps.value))
			if CC_SaveConfiguration
				CC_SaveConfiguration(consoleplayer)
			end
		end
	end}
))

// COMMAND SAVING/LOADING

COM_AddCommand("cc_send", function(player)
	player.cc_nosave = 0
end)

local configplayers = {}

local commandqueue = {}
local function BuildSendBuffer(player, buffer)
	//buffer = "cc_send " .. tostring(player):sub(13) .. " " .. 1 .. ";" .. $
	//buffer = $ .. "cc_send " .. tostring(player):sub(13) .. " " .. 0 .. ";"
	return buffer .. "cc_send;"
end
local function QueueCommand(player, buffer)
	table.insert(commandqueue, buffer)
end
local function SendCommand(player, buffer, hold)
	//print("now executing "..buffer)
	player.cc_nosave = 1
	COM_BufInsertText(splitscreen and consoleplayer or player, BuildSendBuffer(player, buffer))
end

local MESSAGEDELAY = TICRATE/3
local messages = {}
local function PlayMessage(message)
	if message.sound
		S_StartSound(nil, message.sound)
	end
	print("\139ChrispyChars:\128 "..message.text)
end
local function AddDelayedMessage(t, s, sfx)
	local message = {tics = t, text = s, sound = sfx}
	if t < 1
		PlayMessage(message)
	else
		table.insert(messages, 1, message)
	end
end

local FILEVERSION = 0 // increment every time config settings need to be invalidated
local FILENAMES = {
	"client/ChrispyChars.dat",
	"client/ChrispyChars2.dat"
}

local SDF_TOGGLE = 1 << 0
local SDF_DEFAULTTRUE = 1 << 1
local SDF_MULTICVAR = 1 << 2 // I didn't finish adding support for this flag, so don't use it if you're stealing my code

local commands = {
	{
		name = "neck",
		getVar = function(player) return player.cc_neckenabled end,
		flags = SDF_TOGGLE|SDF_DEFAULTTRUE
	},
	{
		name = "curiosity",
		getVar = function(player) return player.cc_curiosityenabled end,
		flags = SDF_TOGGLE|SDF_DEFAULTTRUE
	},
	{
		name = "emotion",
		getVar = function(player) return player.cc_emotionenabled end,
		flags = SDF_TOGGLE|SDF_DEFAULTTRUE
	},
	{
		name = "tricks",
		getVar = function(player) return player.cc_tricksenabled end,
		flags = SDF_TOGGLE
	},
	{
		name = "confetti",
		getVar = function(player) return player.cc_confetticolors end,
		writeValue = function(playerval, player)
			if type(playerval) ~= "table"
				return tostring(playerval)
			end
			
			local ret = ""
			for _, val in ipairs(player.cc_confetticolors)
				if val <= SKINCOLOR_SUPERTAN5
					ret = $ .. val .. " "
				end
			end
			return ret:len() and ret or tostring(nil)
		end
	},
	{
		name = "flicker",
		getVar = function(player) return player.cc_flickerenabled end,
		flags = SDF_TOGGLE|SDF_DEFAULTTRUE
	},
	{
		name = "gauge",
		getVar = function(player) return player.cc_gaugeenabled end,
		flags = SDF_TOGGLE|SDF_DEFAULTTRUE
	},
	{
		name = "thatstails",
		getVar = function(player) return player.cc_thatstailsenabled end,
		flags = SDF_TOGGLE
	},
	{
		name = "dabbutton",
		getVar = function(player) return player.cc_buttonmap and player.cc_buttonmap.dab or nil end,
		default = CC_DEFAULTBUTTONS.dab
	},
	{
		name = "crouchbutton",
		getVar = function(player) return player.cc_buttonmap and player.cc_buttonmap.crouch or nil end,
		default = CC_DEFAULTBUTTONS.crouch
	},
	{
		name = "dancebutton",
		getVar = function(player) return player.cc_buttonmap and player.cc_buttonmap.dance or nil end,
		default = CC_DEFAULTBUTTONS.dance
	},
	{
		name = "menubutton",
		getVar = function(player) return player.cc_buttonmap and player.cc_buttonmap.menu or nil end,
		default = CC_DEFAULTBUTTONS.menu
	},
	{
		name = "bass",
		cvar = cv_bass,
		flags = SDF_TOGGLE|SDF_DEFAULTTRUE
	},
	{
		name = "steps",
		cvar = cv_steps,
		flags = SDF_TOGGLE|SDF_DEFAULTTRUE
	},
	{
		name = "hater",
		getVar = function(player) return player.cc_haterenabled end,
		flags = SDF_TOGGLE
	}
}

local commandindex = {}

for i, val in ipairs(commands)
	commandindex[val.name] = i
end

local function valid(mo)
	return mo and mo.valid
end

local function WriteFile(name, n, defaults)
	local player = configplayers[n]
	local savenum = 0
	local bit = 0
	local savestrings = ""
	
	for i, val in ipairs(commands)
		local flags = val.flags or 0
		local playerval
		if not defaults
			playerval = val.getVar and val.getVar(player)
		end
		
		if val.cvar and player ~= consoleplayer and not (flags & SDF_MULTICVAR)
			continue
		end
		
		if flags & SDF_TOGGLE
			local n
			
			if val.cvar
				n = val.cvar.value
			elseif playerval == nil
				n = flags & SDF_DEFAULTTRUE and 1 or 0
			else
				n = playerval and 1 or 0
			end
			
			savenum = $ + (n << bit)
			bit = $ + 1
		else
			if val.writeValue
				savestrings = $ .. val.writeValue(playerval, player)
			elseif val.cvar
				savestrings = $ .. val.cvar.value
			elseif type(playerval) == "table"
				savestrings = $ .. table.concat(playerval, " ")
			else
				savestrings = $ + tostring(playerval)
			end
			savestrings = $ .. "\n"
		end
	end
	
	local file = io.openlocal(name, "w+")
	file:write(FILEVERSION.."\n") // write version number
	file:write(savenum.."\n") // write toggles
	file:write(savestrings) // write the other bullshit
	
	return file
end

local function OpenFile(name, n)
	local file = io.openlocal(name)
	local message
	if file
		if file:read("*n") == FILEVERSION // assume the file is readable if the version number matches. If you fuck with the file then you shouldn't expect it to work :P
			message = name.."\131 configuration loaded successfully!"
			return file, message, sfx_rmenua
		end
		file:close()
		message = name.."\133 configured for a different version of ChrispyChars. The file was overwritten with default settings.\n\138Press CUSTOM 3 to access the menu and reconfigure your settings!"
	else
		message = name.."\130 configuration not found. A new file with default settings was generated instead.\n\138Press CUSTOM 3 to access the menu and configure your settings!"
	end
	
	return WriteFile(name, n, true), message, sfx_rmenub, true
end

local function ReadFile(file, n, newfile)
	file:seek("set") // start from beginning
	file:read() // skip version line
	
	// load command string
	local netsend = netgame and not newfile
	local player = configplayers[n]
	local suffix = player == consoleplayer and "" or tostring(n)
	local command = ""
	local loadnum = file:read()
	local bit = 0
	
	// this is a HUGE hack, but I don't know the best way around this...
	// for whatever reason, the player reference changes a few tics after joining
	// (I guess the player's client treats them as player 1 while joining?)
	// so I'm queueing some dummy cc_send commands to delay execution of the real commands
	// I have NO idea if this breaks when a player takes longer to join the game due to a slow connection or w/e
	// fingers crossed...
	if netsend
		for i = 1, 3
			QueueCommand(player, "")
		end
	end
	
	// okay now queue the actual commands
	for i, val in ipairs(commands)
		local flags = val.flags or 0
		
		if val.cvar and player ~= consoleplayer and not (flags & SDF_MULTICVAR)
			continue
		end
		
		if flags & SDF_TOGGLE
			command = $ .. val.name .. suffix .. " " .. ((loadnum & (1 << bit)) >> bit) .. ";"
			bit = $ + 1
		else
			local line = file:read()
			if line and line ~= "nil"
				command = $ .. val.name .. suffix .. " " .. line .. ";"
			end
		end
		
		if netsend
			QueueCommand(player, command)
			command = ""
		end
	end
	
	if not netgame
		SendCommand(player, command)
	end
	
	file:close()
end

rawset(_G, "CC_SaveConfiguration", function(player)
	for i = 1, #configplayers
		if configplayers[i] == player
			local name = FILENAMES[i]
			WriteFile(name, i)
			AddDelayedMessage(0, name.."\131 configuration saved successfully!")
			return
		end
	end
end)

addHook("ThinkFrame", do
	local clientplayers = {consoleplayer, secondarydisplayplayer}
	
	// check each client and load a configuration if the session has not done so already
	for i, player in ipairs(clientplayers)
		if not valid(configplayers[i])
		and valid(player)
			local file, message, sound, newfile
			configplayers[i] = player
			file, message, sound, newfile = OpenFile(FILENAMES[i], i)
			ReadFile(file, i, newfile)
			if not modeattacking
			and (newfile or not netgame)
				AddDelayedMessage(MESSAGEDELAY, message, sound)
			end
		end
		configplayers[i] = player
	end
	
	// loaded configurations in netgames are queued and only 1 command is executed per tic, so as not to fill the console buffer
	if #commandqueue and not consoleplayer.cc_nosave
		SendCommand(consoleplayer, table.remove(commandqueue, 1), true)
		if not #commandqueue
			AddDelayedMessage(0, FILENAMES[1] .. "\131 configuration loaded & sent to server!", sfx_rmenua)
		end
	end
	
	// tic and print delayed messages
	for i = #messages, 1, -1
		local message = messages[i]
		message.tics = $ - 1
		if message.tics <= 0
			PlayMessage(message)
			table.remove(messages, i)
		end
	end
end)

// MENU
local MENUS // declaring this up here so the functions can find it - it's defined later on, sorry for the disorganization!

// input calculations
local InputTypes = {
	["up"] = function(cmd) return cmd.forwardmove > 0 end,
	["down"] = function(cmd) return cmd.forwardmove < 0 end,
	["left"] = function(cmd) return cmd.sidemove < 0 end,
	["right"] = function(cmd) return cmd.sidemove > 0 end,
	["jump"] = function(cmd) return cmd.buttons & BT_JUMP end,
	["spin"] = function(cmd) return cmd.buttons & BT_USE end,
	["crouch"] = function(cmd, player) return cmd.buttons & (player.cc_buttonmap and player.cc_buttonmap.crouch or CC_DEFAULTBUTTONS.crouch) end
}

local HOLDTIME = 10

local MENUDIST_H = 360*FRACUNIT
local MENUDIST_V = 20*FRACUNIT

local BUTTONTHEMES = {
	[0] = {SKINCOLOR_CARBON, SKINCOLOR_GREY},
	[V_MAGENTAMAP] = {SKINCOLOR_NEON, SKINCOLOR_MAGENTA},
	[V_YELLOWMAP] = {SKINCOLOR_SUPERRUST4, SKINCOLOR_YELLOW},
	[V_GREENMAP] = {SKINCOLOR_FOREST, SKINCOLOR_EMERALD},
	[V_BLUEMAP] = {SKINCOLOR_COBALT, SKINCOLOR_CORNFLOWER},
	[V_REDMAP] = {SKINCOLOR_CRIMSON, SKINCOLOR_SALMON},
	[V_GRAYMAP] = {SKINCOLOR_CARBON, SKINCOLOR_GREY},
	[V_ORANGEMAP] = {SKINCOLOR_RUST, SKINCOLOR_ORANGE},
	[V_SKYMAP] = {SKINCOLOR_CERULEAN, SKINCOLOR_SKY},
	[V_PURPLEMAP] = {SKINCOLOR_PURPLE, SKINCOLOR_SUPERPURPLE2},
	[V_AQUAMAP] = {SKINCOLOR_SEAFOAM, SKINCOLOR_AQUA},
	[V_PERIDOTMAP] = {SKINCOLOR_FOREST, SKINCOLOR_PERIDOT},
	[V_AZUREMAP] = {SKINCOLOR_DUSK, SKINCOLOR_AZURE},
	[V_BROWNMAP] = {SKINCOLOR_BROWN, SKINCOLOR_YOGURT},
	[V_ROSYMAP] = {SKINCOLOR_RASPBERRY, SKINCOLOR_ROSY},
	[V_INVERTMAP] = {SKINCOLOR_CARBON, SKINCOLOR_GREY},
}

// patches
local BLACK
local ZIGZAGTOP
local ZIGZAGBOTTOM
local ZIGZAGSIDE
local BUTTON

local function CachePatches(v)
	BLACK = v.cachePatch("~030")
	ZIGZAGTOP = v.cachePatch("NTSATKT1")
	ZIGZAGBOTTOM = v.cachePatch("NTSATKB1")
	ZIGZAGSIDE = v.cachePatch("RECATKFG")
	BUTTON = v.cachePatch("ROPTBTN")
end

local function PressOrHold(val)
	return val == 1 or val >= HOLDTIME and val % 3 == HOLDTIME % 3
end
rawset(_G, "CC_PressOrHold", PressOrHold)

local function WaWah(cc)
	if not cc.shake
		cc.shake = TICRATE/3
		S_StartSound(nil, sfx_adderr, cc.player)
	end
end

local function PreviousMenu(cc)
	if MENUS[cc.menus[cc.layer]].onexit and MENUS[cc.menus[cc.layer]].onexit(cc)
		WaWah(cc)
	else
		cc.layer = $ - 1
		cc.transition = $ - MENUDIST_H
		S_StartSound(nil, sfx_rmenub, cc.player)
	end
end

local function DrawPanel(v, player, x, y, radius, color, spread, trans)
	if trans return end
	
	local c = skincolors[color].ramp[12]
	local s = (3*spread/2) >> FRACBITS
	
	for i = 1, spread and 2 or 1
		v.drawFill(x + s - radius, y + s - radius, 2*radius, 2*radius, c|V_PERPLAYER)
		
		c = skincolors[color].ramp[6]
		s = -$
	end
end

local function GetAngNum(angle)
	return (AngleFixed(angle + ANGLE_22h) / (45*FRACUNIT) + 8) % 8 + 1
end

// HAHAHAHAHAHAHAHAHAHAHA
// FUCK
// ideally I would make this use the stuff in Fluffy's script but that's an if-else mess so I'd
// rather just have a separated, simpler function that only needs to meet the menu's requirements
local split_threadnum
local tails_threads = {}
local fluffy_threads = {}
local function TailsRoutine(v, x, y, scale, angle, sprite2, player)
	// defs
	local ANIM_DEFAULT = 1
	local ANIM_SPRING = 2
	local ANIM_FALL = 3
	
	local getanim = {
		[SPR2_SPNG] = ANIM_SPRING,
		[SPR2_FALL] = ANIM_FALL,
		[SPR2_RIDE] = ANIM_FALL
	}
	
	local gettics = {
		[ANIM_DEFAULT] = 5,
		[ANIM_SPRING] = 2,
		[ANIM_FALL] = 2
	}
	
	local getsprite2 = {
		[ANIM_DEFAULT] = SPR2_TAL0,
		[ANIM_SPRING] = SPR2_TAL5,
		[ANIM_FALL] = SPR2_TAL3
	}
	
	local getdist = {
		[ANIM_DEFAULT] = FRACUNIT,
		[ANIM_SPRING] = FRACUNIT/2,
		[ANIM_FALL] = FRACUNIT
	}
	
	local getzoffs = {
		[ANIM_DEFAULT] = 0,
		[ANIM_SPRING] = 4*FRACUNIT,
		[ANIM_FALL] = 0
	}
	
	// vars
	local anim
	local tics
	local frame
	
	print(1)
	
	while true
		local ret = {}
		local tailx = x
		local layer
		local doanim = getanim[sprite2] or ANIM_DEFAULT
		local angnum = GetAngNum(angle)
		
		if anim ~= doanim
			if getsprite2[anim] ~= getsprite2[doanim]
				tics = gettics[doanim]
				frame = A
			end
			anim = doanim
		end
		
		tics = $ - 1
		if not tics
			frame = $ + 1
			if not v.getSprite2Patch("tails", getsprite2[anim], false, frame, angnum)
				frame = A
			end
			tics = gettics[anim]
		end
		
		tailx = $ + FixedMul(FixedMul(scale, getdist[anim]), sin(angle))
		layer = FixedMul(getdist[anim], -cos(angle)) - 1
		
		local patch, flip = v.getSprite2Patch("tails", getsprite2[anim], false, frame, angnum)
		table.insert(ret, {
			x = tailx,
			y = y - FixedMul(scale, getzoffs[anim]),
			layer = layer,
			patch = patch,
			flags = flip and V_FLIP or 0
		})
		
		v, x, y, scale, angle, sprite2, player = coroutine.yield(ret)
	end
end
local function FluffyRoutine(v, x, y, scale, angle, sprite2, player)
	// defs
	local ANIM_DEFAULT = 1
	local ANIM_RUN = 2
	local ANIM_FLY = 3
	local ANIM_TIRE = 4
	local ANIM_DAB = 5
	
	local getanim = {
		[SPR2_FLY] = ANIM_FLY,
		[SPR2_CARY] = ANIM_FLY,
		[SPR2_TIRE] = ANIM_TIRE,
		[SPR2_POSE] = ANIM_DAB,
		[SPR2_RUN] = ANIM_RUN,
		[SPR2_ROLL] = ANIM_RUN
	}
	
	local gettics = {
		[ANIM_DEFAULT] = 4,
		[ANIM_RUN] = 2,
		[ANIM_FLY] = 2,
		[ANIM_TIRE] = 3,
		[ANIM_DAB] = FRACUNIT
	}
	
	local getoffset = {
		[ANIM_DEFAULT] = 2,
		[ANIM_RUN] = 4,
		[ANIM_FLY] = 4,
		[ANIM_TIRE] = 4,
		[ANIM_DAB] = 0
	}
	
	local getsprite2 = {
		[ANIM_DEFAULT] = states[S_FLUFFYTAIL_IDLE].frame,
		[ANIM_RUN] = states[S_FLUFFYTAIL_RUN].frame,
		[ANIM_FLY] = states[S_FLUFFYTAIL_FLY].frame,
		[ANIM_TIRE] = states[S_FLUFFYTAIL_FLY].frame,
		[ANIM_DAB] = states[S_FLUFFYTAIL_DAB].frame
	}
	
	local getdist = {
		[ANIM_DEFAULT] = 11*FRACUNIT,
		[ANIM_RUN] = 7*FRACUNIT,
		[ANIM_FLY] = FRACUNIT,
		[ANIM_TIRE] = FRACUNIT,
		[ANIM_DAB] = 0
	}
	
	// vars
	local anim = 0
	local tics = 0
	local frames = {}
	
	while true
		local ret = {}
		local tailx = x
		local layer
		local doanim = getanim[sprite2] or ANIM_DEFAULT
		local angnum = GetAngNum(angle)
		
		if anim ~= doanim
			if getsprite2[anim] ~= getsprite2[doanim]
				tics = gettics[doanim]
				frames[1] = A
				frames[2] = frames[1] + getoffset[doanim]
			end
			anim = doanim
		end
		
		tics = $ - 1
		if not tics
			for i = 1, #frames
				frames[i] = $ + 1
				if not v.getSprite2Patch("fluffy", getsprite2[anim], i == 1, frames[i], angnum)
					frames[i] = A
				end
			end
			tics = gettics[anim]
		end
		
		tailx = $ + FixedMul(FixedMul(scale, getdist[anim]), sin(angle))
		layer = FixedMul(getdist[anim], -cos(angle)) - 1
		
		for i = 1, #frames
			local patch, flip = v.getSprite2Patch("fluffy", getsprite2[anim], i == 1, frames[i], angnum)
			table.insert(ret, {
				x = tailx,
				y = y,
				layer = layer + 2*(i - 1),
				patch = patch,
				flags = flip and V_FLIP or 0
			})
		end
		
		if (anim == ANIM_RUN
		or anim == ANIM_FLY)
		and frames[1] & 1 == 0
		and player.cc_flickerenabled ~= false
			local patch, flip = v.getSprite2Patch("fluffy", states[S_FLUFFYTAIL_BLUR].frame, false, anim == ANIM_RUN and B or A, angnum)
			table.insert(ret, {
				x = tailx,
				y = y,
				layer = layer + 2*#frames,
				patch = patch,
				flags = flip and V_FLIP or 0,
				half = true
			})
		end
		
		v, x, y, scale, angle, sprite2, player = coroutine.yield(ret)
	end
end
local function DrawPlayer(v, x, y, scale, player, skin, sprite2, frame, angle, trans, halftrans, colormap, shiftthread)
	local todraw = {}
	
	if player
		if player.cc_thatstailsenabled
		or skin == "fluffy" and sprite2 ~= SPR2_CNT1
			local threadnum = split_threadnum << (shiftthread or 0)
			if not fluffy_threads[threadnum]
				fluffy_threads[threadnum] = coroutine.create(FluffyRoutine)
			end
			todraw = select(2, coroutine.resume(fluffy_threads[threadnum], v, x, y, scale, angle, sprite2, player))
		elseif skins[skin].followitem == MT_TAILSOVERLAY
			local threadnum = split_threadnum << (shiftthread or 0)
			if not tails_threads[threadnum]
				tails_threads[threadnum] = coroutine.create(TailsRoutine)
			end
			todraw = select(2, coroutine.resume(tails_threads[threadnum], v, x, y, scale, angle, sprite2, player))
		end
	end
	
	if skin
		local angnum = GetAngNum(angle)
		local patch, flip = v.getSprite2Patch(skin, sprite2, false, frame, angnum)
		table.insert(todraw, {
			x = x,
			y = y,
			layer = 0,
			patch = patch,
			flags = flip and V_FLIP or 0
		})
		
		if sprite2 == SPR2_ROLL
		and frame % 3 == 1
		and skin == "pointy"
			patch, flip = v.getSprite2Patch(skin, SPR2_TWIN, false, (2*(frame/3) + 1), angnum)
			table.insert(todraw, {
				x = x,
				y = y,
				layer = 1,
				patch = patch,
				flags = flip and V_FLIP or 0,
				half = true
			})
		end
	end
	
	while #todraw
		local item
		local bottom = 1
		for i = 2, #todraw
			if todraw[i].layer < todraw[bottom].layer
				bottom = i
			end
		end
		item = todraw[bottom]
		if item.half
			item.flags = $ | halftrans
		else
			item.flags = $ | trans
		end
		if item.flip
			item.flags = $ | V_FLIP
		end
		if item.patch
			v.drawScaled(item.x, item.y, scale, item.patch,
			item.flags|V_PERPLAYER, colormap)
		end
		table.remove(todraw, bottom)
	end
end

-- v is the drawer
-- x, y are screen coordinates, fixed scale
-- text is the string to display
-- font is the patch prefix
-- alignment: -1 = right-aligned, 1 = left-aligned, 0 = centered
-- color is a skincolor
-- shadow determines whether or not to draw a pure-black copy of the text underneath, offset to the right and down
local function DrawMenuString(v, x, y, xscale, yscale, text, font, flags, alignment, color, shadow)
	local colormap = v.getColormap(TC_DEFAULT, color or 0)
	local shadowmap = shadow and v.getColormap(TC_DEFAULT, SKINCOLOR_CHRISP)
	local start
	local finish
	local dispx = x
	local dispy = y
	local items = {}
	local startitem = #items + 1
	local totalwidth = 0
	
	local function NewLine()
		dispx = x
		dispy = $ + (v.cachePatch(font..32).height + 1)*yscale // height of the space character + 1
		
		if alignment > 0
			return
		end
		if alignment == 0
			totalwidth = $/2
		end
		
		for j = startitem, #items
			items[j].x = $ - totalwidth
		end
		startitem = #items + 1
		totalwidth = 0
	end
	
	text = tostring(text)
	
	start = 1
	finish = text:len()
	
	for i = start, finish
		local letter = text:sub(i, i):byte()
		if letter == 10
			NewLine()
			continue
		end
		
		letter = font .. $
		if not v.patchExists(letter)
			continue
		end
		
		local patch = v.cachePatch(letter)
		local width = (patch.width + 1)*xscale
		
		table.insert(items, {patch = patch, x = dispx, y = dispy})
		dispx = $ + width
		totalwidth = $ + width
	end
	
	NewLine()
	
	if shadow
		for i, item in ipairs(items)
			v.drawStretched(item.x + xscale, item.y + yscale, xscale, yscale, item.patch, flags, shadowmap)
		end
	end
	
	for i, item in ipairs(items)
		v.drawStretched(item.x, item.y, xscale, yscale, item.patch, flags, colormap)
	end
end

// menu pages
local ConfettiVisual = function(v, x, y, player, playerval, trans, halftrans)
	local info = mobjinfo[MT_CHRISPY_CONFETTI]
	local angspeed = info.painchance
	local rollspeed = FixedAngle(states[S_CHRISPY_CONFETTI].var1*FRACUNIT)
	
	local skin = player.mo and player.mo.skin or "pointy"
	local color = player.mo and player.skincolor or skins[skin].prefcolor
	local colormap = v.getColormap(skin, color)
	
	local delay = 8
	local angle = 0
	
	local conf_front = {}
	local conf_back = {}
	
	local function SpawnConfetti(n)
		local list = player.cc_confetticolors or CC_DEFAULT_CONFETTI_COLORS
		
		while n
			local part = {
				x = x,
				y = y - skins[skin].height,
				momx = v.RandomRange(-9, 9) * FRACUNIT,
				momy = v.RandomRange(-12, 0) * FRACUNIT,
				colormap = v.getColormap(TC_DEFAULT, list[v.RandomKey(#list) + 1] or player.skincolor),
				angle = FixedAngle(v.RandomKey(360)*FRACUNIT),
				roll = FixedAngle(v.RandomKey(360)*FRACUNIT),
				flags = 0
			}
			if v.RandomKey(2)
				table.insert(conf_front, part)
			else
				table.insert(conf_back, part)
			end
			n = $ - 1
		end
	end
	
	local function ProcessConfetti(tab, i)
		local conf = tab[i]
		if conf.y > y + 24*FRACUNIT
			table.remove(tab, i)
			return
		end
		
		if not (conf.flags & 2)
			conf.momy = $ + (FRACUNIT >> 1)
		end
		
		conf.x = $ + conf.momx
		conf.y = $ + conf.momy
		conf.angle = $ + angspeed
		conf.roll = $ + rollspeed
		
		// reduce speed
		if not (conf.flags & 1)
			conf.momx = FixedMul($, info.mass)
			conf.momy = FixedMul($, info.mass)
			if FixedHypot(conf.momx, conf.momy) < FRACUNIT
				conf.momx = 0
				conf.flags = $ | 1
			end
		elseif not (conf.flags & 2) // limit fall speed
			local maxfall = info.speed
			if conf.momy > maxfall
				conf.momy = FixedMul($, info.mass)
				if conf.momy < maxfall
					conf.momy = maxfall
					conf.flags = $ | 2
				end
			end
		end
		
		local patch, _, offset = v.getSpritePatch(SPR_CONF, A, 0, conf.roll)
		v.drawStretched(conf.x, conf.y - (not offset and 4*FRACUNIT or 0),
			abs(sin(conf.angle)), FRACUNIT, patch, trans|V_PERPLAYER, conf.colormap)
	end
	
	while true
		if angle
			angle = $ - ANGLE_22h
		elseif delay
			delay = $ - 1
			if not delay
				angle = ANGLE_45*7
				delay = 12
				S_StartSound(nil, CC_TRICKS[#CC_TRICKS].sound, player)
				SpawnConfetti(12)
			end
		end
		
		// calculate confetti movement and draw everything
		for i = #conf_back, 1, -1
			ProcessConfetti(conf_back, i)
		end
		DrawPlayer(v, x, y, FRACUNIT, player, skin, SPR2_SPNG, 0, ANGLE_45 + angle, trans, halftrans, colormap)
		for i = #conf_front, 1, -1
			ProcessConfetti(conf_front, i)
		end
		
		playerval, trans, halftrans = coroutine.yield()
	end
end
local CONFETTIMENU = {
	name = "CONFETTI SETUP",
	command = "confetti",
	onenter = function(cc)
		local colors = {0}
		for i = 1, #skincolors - 1
			if skincolors[i].accessible
				table.insert(colors, i)
			end
		end
		cc.conf_skincolors = colors
		cc.conf_scroll = 0
	end,
	custommenu = function(cc)
		local player = cc.player
		if cc.selections[cc.layer] < 1 // back & reset buttons
			if cc.jump == 1
				if cc.selections[cc.layer] == -1
					local suffix = player == secondarydisplayplayer and "2" or ""
					local buffer = MENUS[cc.menus[cc.layer]].command .. suffix .. " " .. "default;"
					
					SendCommand(player, buffer)
					
					S_StartSound(nil, sfx_rmenua, player)
					cc.spread = 0
					cc.pulse = 2*FRACUNIT
					cc.changed = true
				else
					PreviousMenu(cc)
					cc.spread = 0
				end
			elseif PressOrHold(cc.right)
				cc.selections[cc.layer] = cc.conf_lastsel
				cc.spread = 0
				S_StartSound(nil, sfx_rmenu1, player)
			elseif PressOrHold(cc.up)
			or PressOrHold(cc.down)
				cc.spread = 0
				cc.selections[cc.layer] = -$ - 1
				S_StartSound(nil, sfx_rmenu1, player)
			end
		else
			if cc.jump == 1 or cc.spin == 1
				local prefix = cc.jump == 1 and "+" or "-"
				local sound = cc.jump == 1 and sfx_rmenua or sfx_rmenub
				local suffix = player == secondarydisplayplayer and "2" or ""
				local buffer = MENUS[cc.menus[cc.layer]].command .. suffix .. " " .. prefix .. cc.conf_skincolors[cc.selections[cc.layer]] .. ";"
				
				SendCommand(player, buffer)
				
				S_StartSound(nil, sound, player)
				cc.spread = 0
				cc.pulse = 2*FRACUNIT
				cc.changed = true
			end
			if PressOrHold(cc.down)
				if cc.selections[cc.layer] + 5 <= #cc.conf_skincolors
					cc.selections[cc.layer] = $ + 5
					cc.spread = 0
					S_StartSound(nil, sfx_rmenu1, player)
				end
			elseif PressOrHold(cc.up)
				if cc.selections[cc.layer] - 5 > 0
					cc.selections[cc.layer] = $ - 5
					cc.spread = 0
					S_StartSound(nil, sfx_rmenu1, player)
				end
			end
			if PressOrHold(cc.left)
				if cc.selections[cc.layer] % 5 == 1
					cc.conf_lastsel = cc.selections[cc.layer]
					cc.selections[cc.layer] = 0
					cc.spread = 0
					S_StartSound(nil, sfx_rmenu1, player)
				else
					cc.selections[cc.layer] = $ - 1
					cc.spread = 0
					S_StartSound(nil, sfx_rmenu1, player)
				end
			elseif PressOrHold(cc.right)
				if cc.selections[cc.layer] % 5
				and cc.selections[cc.layer] < #cc.conf_skincolors
					cc.selections[cc.layer] = $ + 1
					cc.spread = 0
					S_StartSound(nil, sfx_rmenu1, player)
				end
			end
		end
	end,
	customdraw = function(v, cc, i, trans)
		local player = cc.player
		local sel = cc.selections[cc.layer + i]
		local buttontheme = BUTTONTHEMES[skincolors[splitscreen and player.skincolor or ColorOpposite(player.skincolor)].chatcolor]
		local x = 160*FRACUNIT + cc.transition + i*MENUDIST_H + ((cc.shake + 1) % 3 - 1)*FRACUNIT
		local y = 66*FRACUNIT
		local screenheight = v.height()/v.dupy()*FRACUNIT
		
		local offset = 36*FRACUNIT
		local xoff = -2*offset
		local yoff = 0
		local yawspeed = mobjinfo[MT_CHRISPY_CONFETTI].painchance
		local rollspeed = states[S_CHRISPY_CONFETTI].var1
		local confscale = 2*FRACUNIT
		local halfscale = FRACUNIT >> 1
		
		local backx = x - 112*FRACUNIT
		local backy = 54*FRACUNIT
		local clearx = backx
		local cleary = backy + offset
		local cursorx = x + xoff + ((sel - 1) % 5)*offset
		local cursory = y + (sel - 1)/5*offset - 4*FRACUNIT
		
		local activecolors = {}
		
		if sel < 1
			cursorx = backx
			cursory = (sel and cleary or backy) + 4*FRACUNIT
			if sel == -1
				clearx = $ - cc.spread
				cleary = $ - cc.spread
			else
				backx = $ - cc.spread
				backy = $ - cc.spread
			end
			DrawPanel(v, player, cursorx >> FRACBITS, cursory >> FRACBITS, 18, buttontheme[1], cc.spread, trans)
		else
			cc.conf_scroll = max(0, $ + (cursory - 2*screenheight/3 - $)/6)
		end
		DrawMenuString(v, backx, backy, FRACUNIT, FRACUNIT, "Back", "RFNT", trans|V_PERPLAYER, 0, sel == 0 and SKINCOLOR_SUPERGOLD5 or SKINCOLOR_BONE, true)
		DrawMenuString(v, clearx, cleary, FRACUNIT, FRACUNIT, "Clear", "RFNT", trans|V_PERPLAYER, 0, sel == -1 and SKINCOLOR_SUPERGOLD5 or SKINCOLOR_BONE, true)
		
		if player.cc_confetticolors
			for _, c in ipairs(player.cc_confetticolors)
				activecolors[c] = $ and $ + 1 or 1
			end
		end
		
		local j = 0
		while j < #cc.conf_skincolors
			j = $ + 1
			while yoff - cc.conf_scroll < -8*FRACUNIT
				yoff = $ + offset
				j = $ + 5
			end
			
			local color = cc.conf_skincolors[j]
			
			local spread = 0
			local xscale = FixedMul(confscale, sin((cc.count + j)*yawspeed))
			local patch = v.getSpritePatch(SPR_CONF, 0, 0, FixedAngle((cc.count + j)*rollspeed*FRACUNIT))
			local colorname = color and skincolors[color].name or "Player color"
			local stringcolor = SKINCOLOR_BONE
			local stringheight = halfscale
			
			if j == sel
				spread = cc.spread
				DrawPanel(v, player, cursorx >> FRACBITS, (cursory - cc.conf_scroll) >> FRACBITS, 18, buttontheme[1], cc.spread, trans)
			end
			
			if activecolors[color]
				colorname = $ .. " x" .. activecolors[color]
				stringcolor = SKINCOLOR_SUPERGOLD5
				stringheight = 4*$/3
			end
			
			v.drawStretched(x + xoff - spread, y + yoff - cc.conf_scroll - spread, abs(xscale), confscale, patch, trans|V_PERPLAYER, v.getColormap(TC_DEFAULT, color or player.skincolor))
			DrawMenuString(v, x + xoff - spread, y + yoff - cc.conf_scroll - spread + 2*FRACUNIT, halfscale, stringheight, colorname, "RFNT", trans|V_PERPLAYER, 0, stringcolor, true)
			
			if j % 5 == 0
				xoff = -2*offset
				yoff = $ + offset
				if y + yoff - cc.conf_scroll > screenheight
					break
				end
			else
				xoff = $ + offset
			end
		end
	end,
	command = "confetti",
	visual = ConfettiVisual,
	controls = "Up/Down/Left/Right: Cursor" +
		"\nJump: Add color" +
		"\nSpin: Remove color"
}

local GLOBALMENU = {
	name = "GLOBAL SETTINGS",
	[1] = {
		name = "Footsteps",
		command = "steps",
		desc = "Hear footsteps, squeals, and other\nnoises made by ChrispyChars.",
		visual = function(v, x, y, player, playerval, trans, halftrans)
			local skin = player.mo and player.mo.skin
			local ischrispy = IsChrispySkin(skin)
			local color, colormap
			local state = S_PLAY_WALK
			local frame = 0
			local tics = 3
			local reps = 1
			local repeater = 0
			local repeatsound
			
			skin = ischrispy and $ or "fluffy"
			color = ischrispy and player.skincolor or skins[skin].prefcolor
			colormap = v.getColormap(skin, color)
			
			while true
				local sound = 0
				
				if tics // continue displayed frame
					tics = $ - 1
				end
				if not tics // change frame
					local sounds
					
					frame = $ + 1
					if not v.getSprite2Patch(skin, states[state].frame, false, frame, 2) // out of frames? switch state
						frame = 0
						if reps
							reps = $ - 1
						else
							state = $ == S_PLAY_WALK and S_PLAY_RUN or S_PLAY_WALK
							reps = state == S_PLAY_WALK and 1 or 5
						end
					end
					
					tics = states[state].tics
					sounds = CC_Footsteps[skin][states[state].frame] // get footstep to play, if one exists
					if sounds.repeatsound
						if repeatsound ~= sounds.repeatsound
							repeatsound = sounds.repeatsound
							repeater = repeatsound >> FRACBITS
							sound = repeatsound & (FRACUNIT - 1)
						end
					else
						repeatsound = nil
						sound = sounds and sounds[frame] or 0
					end
				end
				
				// play sound
				if repeatsound
					repeater = $ - 1
					if not repeater
						repeater = repeatsound >> FRACBITS
						sound = repeatsound & (FRACUNIT - 1)
					end
				end
				
				if playerval
					while sound & (FRACUNIT - 1)
						S_StartSound(nil, sound & (FRACUNIT - 1), player)
						sound = $ >> FRACBITS
					end
				end
				
				// draw visual
				DrawPlayer(v, x, y, FRACUNIT, player, skin, states[state].frame, frame, ANGLE_45, trans, halftrans, colormap)
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	[2] = {
		name = "Bass",
		command = "bass",
		desc = "Experience noise and screenshake\nwhen nearby dabbing players.",
		visual = function(v, x, y, player, playerval, trans, halftrans)
			local skin = player.mo and player.mo.skin
			local ischrispy = IsChrispySkin(skin)
			local color, colormap, posx, posy
			local count = 0
			
			skin = ischrispy and $ or "pointy"
			color = ischrispy and player.skincolor or skins[skin].prefcolor
			colormap = v.getColormap(skin, color)
			
			while true
				if playerval
					count = $ + 1
					posx = x + (((count % (2*TICRATE)) ^ 2) % 5 - 2)*FRACUNIT
					posy = y + (((count % (2*TICRATE)) ^ 3) % 5 - 2)*FRACUNIT
					S_StartSoundAtVolume(nil, sfx_dab, 128, player)
				else
					posx = x
					posy = y
				end
				DrawPlayer(v, posx, posy, FRACUNIT, player, skin, SPR2_POSE, 0, 0, trans, halftrans, colormap)
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	[3] = {
		name = "Tricks",
		command = "tricks",
		desc = "Tap jump to perform tricks from\nsprings, regardless of character choice.",
		visual = function(v, x, y, player, playerval, trans, halftrans)
			local skin = player.mo and player.mo.skin or "fluffy"
			local trickset = CC_TrickSkins[skin] or CC_TrickSkins["DEFAULT"]
			local color = player.mo and player.skincolor or skins[skin].prefcolor
			
			if trickset.alwaysenabled
				skin = "fluffy"
				trickset = CC_TrickSkins[skin]
				color = skins[skin].prefcolor
			end
			
			local colormap = v.getColormap(skin, color)
			local delay = 0
			local angle = 0
			local momz = FRACUNIT
			local posy = y - 24*FRACUNIT
			
			local springstate = mobjinfo[MT_BLUESPRING].spawnstate
			local springtics = states[springstate].tics
			local springsprite = states[springstate].sprite
			local springframe = states[springstate].frame
			
			y = $ + 12*FRACUNIT
			
			while true
				if angle
					angle = $ - ANGLE_22h
				end
				if delay
					delay = $ - 1
					if not delay
					and player.cc_tricksenabled
						angle = ANGLE_45*7
						S_StartSound(nil, CC_TRICKS[1].sound, player)
					end
				end
				momz = $ + FRACUNIT/3 // gravity is inverse on the HUD!
				
				if posy + momz > y
					posy = y
					momz = -7*FRACUNIT
					delay = 5
					
					S_StartSoundAtVolume(nil, sfx_spring, 128, player)
					springstate = mobjinfo[MT_BLUESPRING].raisestate
					springtics = states[springstate].tics
					springsprite = states[springstate].sprite
					springframe = states[springstate].frame
				end
				posy = $ + momz
				
				if springtics > 0
					springtics = $ - 1
					if not springtics
						springstate = states[springstate].nextstate
						springtics = states[springstate].tics
						springsprite = states[springstate].sprite
						springframe = states[springstate].frame
					end
				end
				
				v.drawScaled(x, y + mobjinfo[MT_BLUESPRING].height, FRACUNIT, v.getSpritePatch(springsprite, springframe), trans|V_PERPLAYER)
				DrawPlayer(v, x, posy, FRACUNIT, player, skin, momz < 0 and SPR2_SPNG or SPR2_FALL, 0, ANGLE_45 + angle, trans, halftrans, colormap)
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	[4] = {
		name = "Confetti",
		menu = CONFETTIMENU,
		desc = "Select confetti colors for\nPERFECT! trick chains and dabs.",
		visual = ConfettiVisual,
		controls = "Up/Down: Cursor" +
			"\nJump: Select" +
			"\nSpin: Back"
	},
	[5] = {
		name = "Is that Tails?",
		command = "thatstails",
		on = "That's Tails!",
		off = "No",
		visual = function(v, x, y, player, playerval, trans, halftrans)
			local colormap = v.getColormap(TC_DEFAULT, SKINCOLOR_RED)
			local patch = v.cachePatch("THATSTAILS")
			
			while true
				if playerval
					DrawPlayer(v, x, y, FRACUNIT, player, nil, SPR2_STND, 0, ANGLE_45, trans, halftrans, colormap)
				end
				v.drawScaled(x, y, FRACUNIT, patch, trans|V_PERPLAYER, colormap)
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	controls = "Up/Down: Cursor" +
		"\nLeft/Right: Change" +
		"\nJump: Change" +
		"\nSpin: Back"
}

local CHRISPYMENU = {
	name = "CHRISPYCHARS SETTINGS",
	[1] = {
		name = "Neck",
		command = "neck",
		desc = "Rotate the character's head to look\nat objects or in the camera direction.",
		visual = function(v, x, y, player, playerval, trans, halftrans)
			local skin = player.mo and player.mo.skin
			local neckinfo
			local color, colormap
			
			if skin and CC_NeckSkins[skin]
				color = player.skincolor
			else
				skin = "pointy"
				color = skins[skin].prefcolor
			end
			neckinfo = CC_NeckSkins[skin]
			colormap = v.getColormap(skin, color)
			
			if not neckinfo.registered
				CC_RegisterNeckInfo(neckinfo, skin)
			end
			
			local pitches = neckinfo.pitches
			local span = max(ANGLE_90, neckinfo.pitchinterval * pitches)
			local halfspan = span/2
			
			local count = 0
			local headaiming = 0
			local headangle = ANGLE_45
			
			while true
				local aiming = 0
				local angle = ANGLE_45
				local frame
				
				if playerval
					count = $ + ANG2
					aiming = $ + 2*count
					if abs(aiming) > ANGLE_90
						aiming = ANGLE_90 - ($ - ANGLE_90)
					end
					angle = $ + FixedMul(ANGLE_90 - 1, sin(count))
					aiming = min(max($, -halfspan), halfspan)
					
					headaiming = $ + FixedMul(aiming - $, neckinfo.speed)
					headangle = $ + FixedMul(angle - $, neckinfo.speed)
				else
					headangle = angle
					headaiming = 0
				end
				
				frame = pitches*(AngleFixed(headaiming + halfspan) - 1)/AngleFixed(span)
				
				DrawPlayer(v, x, y, FRACUNIT, nil, skin, SPR2_HEDB, frame, headangle, trans, halftrans, colormap)
				DrawPlayer(v, x, y, FRACUNIT, player, skin, SPR2_BODY, A, ANGLE_45, trans, halftrans, colormap)
				DrawPlayer(v, x, y, FRACUNIT, nil, skin, SPR2_HEDF, frame, headangle, trans, halftrans, colormap)
				playerval, trans, halftrans = coroutine.yield()
			end
		end	
	},
	[2] = {
		name = "Curiosity",
		command = "curiosity",
		desc = "Track notable objects within range.\n(Requires Neck enabled.)",
		visual = function(v, x, y, player, playerval, trans, halftrans) // I probably should have generalized the neck-based visuals a bit but
			local skin = player.mo and player.mo.skin
			local neckinfo
			local color, colormap
			
			if skin and CC_NeckSkins[skin]
				color = player.skincolor
			else
				skin = "pointy"
				color = skins[skin].prefcolor
			end
			neckinfo = CC_NeckSkins[skin]
			colormap = v.getColormap(skin, color)
			
			if not neckinfo.registered
				CC_RegisterNeckInfo(neckinfo, skin)
			end
			
			local crawlagoal = ANGLE_90
			local crawlaangle = 0
			local crawlax = -16*FRACUNIT
			local crawladepth = 22*FRACUNIT
			local crawlaspeed = mobjinfo[MT_BLUECRAWLA].speed*FRACUNIT
			local crawlaviewheight = mobjinfo[MT_BLUECRAWLA].height >> 1
			local crawlastate = mobjinfo[MT_BLUECRAWLA].seestate
			local crawlatics = states[crawlastate].tics
			local dist = FixedHypot(crawlax, crawladepth)
			local angnum = 0
			
			local pitches = neckinfo.pitches
			local span = max(ANGLE_90, neckinfo.pitchinterval * pitches)
			local halfspan = span/2
			
			local count = 0
			local headangle = R_PointToAngle2(0, 0, crawladepth, -crawlax)
			local headaiming = R_PointToAngle2(0, 3*skins[skin].height/4, dist, crawlaviewheight)
			
			local emotetime = 0
			local emotelife = 0
			
			while true
				// crawla calculations
				local crawlapatch, crawlaflip
				
				if not crawlatics
					crawlastate = states[crawlastate].nextstate
					crawlatics = states[crawlastate].tics
					crawlax = $ - FixedMul(sin(crawlaangle), crawlaspeed)
					if crawlax < -48*FRACUNIT
						crawlagoal = -ANGLE_90
					elseif crawlax > 48*FRACUNIT
						crawlagoal = ANGLE_90
					end
					if crawlaangle ~= crawlagoal
						crawlaangle = $ + min(max(crawlagoal - crawlaangle, -ANGLE_45), ANGLE_45)
						angnum = GetAngNum(crawlaangle)
					end
					dist = FixedHypot(crawlax, crawladepth)
				end
				crawlatics = $ - 1
				crawlapatch, crawlaflip = v.getSpritePatch(states[crawlastate].sprite, states[crawlastate].frame, angnum)
				
				// player calculations
				local aiming = 0
				local angle = 0
				local frame
				
				if not playerval
					count = $ + ANG2
					aiming = $ + 2*count
					if abs(aiming) > ANGLE_90
						aiming = ANGLE_90 - ($ - ANGLE_90)
					end
					angle = $ + FixedMul(ANGLE_90 - 1, sin(count))
					aiming = min(max($, -halfspan), halfspan)
				else
					angle = R_PointToAngle2(0, 0, crawladepth, -crawlax)
					aiming = R_PointToAngle2(0, 3*skins[skin].height/4, dist, crawlaviewheight)
				end
				
				headaiming = $ + FixedMul(aiming - $, neckinfo.speed)
				headangle = $ + FixedMul(angle - $, neckinfo.speed)
				
				frame = pitches*(AngleFixed(headaiming + halfspan) - 1)/AngleFixed(span)
				
				// emote calculations
				local emotey = skins[skin].height + 18*FRACUNIT + neckinfo.emoteoffset
				local emotescale
				local emotecolor = SKINCOLOR_SUPERGOLD5
				
				if playerval and player.cc_emotionenabled ~= false
					emotelife = min($ + 1, 10)
				else
					emotelife = max($ - 2, 0)
				end
				
				emotescale = emotelife * FRACUNIT/10
				emotetime = ($ + 1) % 12
				if emotetime < 6
					emotescale = 3*$/2
					emotey = $ - 2*emotescale
					emotecolor = SKINCOLOR_RED
				end
				
				// draw
				DrawPlayer(v, x, y, FRACUNIT, nil, skin, SPR2_HEDB, frame, headangle, trans, halftrans, colormap)
				DrawPlayer(v, x, y, FRACUNIT, player, skin, SPR2_BODY, A, 0, trans, halftrans, colormap)
				DrawPlayer(v, x, y, FRACUNIT, nil, skin, SPR2_HEDF, frame, headangle, trans, halftrans, colormap)
				v.drawScaled(x, y - emotey, emotescale,
					v.getSpritePatch(SPR_EMOT, C), trans|V_PERPLAYER, v.getColormap("pointy", emotecolor))
				v.drawScaled(x + crawlax, y + 16*FRACUNIT, FRACUNIT, crawlapatch, trans|V_PERPLAYER|(crawlaflip and V_FLIP or 0))
				
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	[3] = {
		name = "Emotion",
		command = "emotion",
		desc = "Display emoticons above the head while tracking objects.\n(Requires Neck and Curiosity enabled.)",
		visual = function(v, x, y, player, playerval, trans, halftrans) // dammit dammit
			local skin = player.mo and player.mo.skin
			local neckinfo
			local color, colormap
			
			if skin and CC_NeckSkins[skin]
				color = player.skincolor
			else
				skin = "pointy"
				color = skins[skin].prefcolor
			end
			neckinfo = CC_NeckSkins[skin]
			colormap = v.getColormap(skin, color)
			
			if not neckinfo.registered
				CC_RegisterNeckInfo(neckinfo, skin)
			end
			
			local flicky = {
				angle = ANGLE_180,
				x = -48*FRACUNIT,
				y = 0,
				depth = 25*FRACUNIT,
				speed = 4*FRACUNIT/5,
				viewheight = mobjinfo[MT_FLICKY_01].height >> 1,
				state = S_FLICKY_01_FLAP1,
				tics = states[S_FLICKY_01_FLAP1].tics,
				angnum = 5,
			}
			local monitor = {
				type = MT_RING_BOX,
				x = 38*FRACUNIT,
				y = 4*FRACUNIT,
				depth = 8*FRACUNIT,
				viewheight = mobjinfo[MT_RING_BOX].height >> 1,
				state = mobjinfo[MT_RING_BOX].spawnstate,
				tics = states[mobjinfo[MT_RING_BOX].spawnstate].tics,
				angnum = 0
			}
			local objs = {flicky, monitor}
			for _, obj in ipairs(objs)
				obj.dist = FixedHypot(obj.x, obj.depth)
				obj.patch, obj.flip = v.getSpritePatch(states[obj.state].sprite, states[obj.state].frame, obj.angnum)
			end
			
			local pitches = neckinfo.pitches
			local span = max(ANGLE_90, neckinfo.pitchinterval * pitches)
			local halfspan = span/2
			
			local count = 0
			local headangle = R_PointToAngle2(0, 0, monitor.depth, -monitor.x)
			local headaiming = R_PointToAngle2(0, 3*skins[skin].height/4, monitor.dist, monitor.viewheight)
			local target
			
			local emotetime = 0
			local emotelife = 0
			
			x = $ - 20*FRACUNIT
			
			while true
				// object calculations
				flicky.angle = $ + (5*ANG1 >> 1)
				flicky.angnum = GetAngNum(flicky.angle)
				flicky.x = $ - FixedMul(sin(flicky.angle), flicky.speed)
				flicky.depth = $ + FixedMul(cos(flicky.angle), flicky.speed)
				flicky.y = flicky.depth / 3 - 48*FRACUNIT
				flicky.dist = FixedHypot(flicky.x, flicky.depth)
				for _, obj in ipairs(objs)
					if not obj.tics
						obj.state = states[$].nextstate
						if obj.state == S_SPAWNSTATE
							obj.state = mobjinfo[obj.type].spawnstate
						end
						obj.tics = states[obj.state].tics
					end
					obj.tics = $ - 1
					obj.patch, obj.flip = v.getSpritePatch(states[obj.state].sprite, states[obj.state].frame, obj.angnum)
				end
				
				// player calculations
				local aiming = 0
				local angle = 0
				local frame
				
				if flicky.dist < monitor.dist
					if target ~= flicky
						target = flicky
						if playerval
							S_StartSound(nil, sfx_emot4, player)
						end
					end
				else
					if target ~= monitor
						target = monitor
						if playerval
							S_StartSound(nil, sfx_emot2, player)
						end
					end
				end
				
				angle = R_PointToAngle2(0, 0, target.depth, -target.x)
				aiming = R_PointToAngle2(0, 3*skins[skin].height/4, target.dist, target.viewheight - target.y)
				
				headaiming = $ + FixedMul(aiming - $, neckinfo.speed)
				headangle = $ + FixedMul(angle - $, neckinfo.speed)
				
				frame = pitches*(AngleFixed(headaiming + halfspan) - 1)/AngleFixed(span)
				
				// emote calculations
				local emotey = skins[skin].height + 14*FRACUNIT + neckinfo.emoteoffset
				local emotescale
				local emotecolor
				local emoteroll
				local emoteframe
				local emotepatch, _, emoteoffset
				
				if playerval
					emotelife = min($ + 1, 10)
				else
					emotelife = max($ - 2, 0)
				end
				
				emotescale = emotelife * FRACUNIT/10
				
				if target == flicky
					emotetime = ($ + 1) % 72
					emotey = $ + 3*FixedMul(sin(emotetime*(ANG10/2)), emotescale)
					if leveltime/3 % 7 == 0
						emotescale = 4*$/3
						emotey = $ - 2*emotescale
					end
					emoteroll = 0
					emotecolor = SKINCOLOR_ROSY
					emoteframe = D
				else
					emotetime = ($ + 1) % 36
					emotey = $ + 6*FixedMul(abs(sin(emotetime*ANG10)), emotescale)
					emoteroll = FixedMul(ANG30, cos(emotetime*ANG10))
					emotecolor = SKINCOLOR_SUPERGOLD5
					emoteframe = B
				end
				
				emotepatch, _, emoteoffset = v.getSpritePatch(SPR_EMOT, emoteframe, 0, emoteroll)
				if emoteoffset
					emotey = $ - 4*FRACUNIT
				end
				
				// draw
				DrawPlayer(v, x, y, FRACUNIT, nil, skin, SPR2_HEDB, frame, headangle, trans, halftrans, colormap)
				DrawPlayer(v, x, y, FRACUNIT, player, skin, SPR2_BODY, A, 0, trans, halftrans, colormap)
				DrawPlayer(v, x, y, FRACUNIT, nil, skin, SPR2_HEDF, frame, headangle, trans, halftrans, colormap)
				v.drawScaled(x, y - emotey, emotescale,
					emotepatch, trans|V_PERPLAYER, v.getColormap("pointy", emotecolor))
				for _, obj in ipairs(objs)
					v.drawScaled(x + obj.x, y + obj.y, FRACUNIT, obj.patch, trans|V_PERPLAYER|(obj.flip and V_FLIP or 0))
				end
				
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	[4] = {
		name = "Flicker",
		command = "flicker",
		desc = "Display translucency effects\nduring roll and certain tail animations.",
		visual = function(v, x, y, player, playerval, trans, halftrans)
			local skin = player.mo and player.mo.skin == "fluffy" and player.mo.skin or "pointy"
			local color = player.mo and player.mo.skin == skin and player.skincolor or skins[skin].prefcolor
			local colormap = v.getColormap(skin, color)
			local state = skin == "fluffy" and S_PLAY_RUN or S_PLAY_ROLL
			local frame = 0
			local tics = 2
			local reps = 5
			
			while true
				if tics // continue displayed frame
					tics = $ - 1
				end
				if not tics // change frame
					repeat frame = $ + 1
					until state ~= S_PLAY_ROLL
					or player.cc_flickerenabled ~= false
					or (frame & FF_FRAMEMASK) % 3 == 0
					
					if not v.getSprite2Patch(skin, states[state].frame, false, frame, 2) // out of frames? switch state
						frame = 0
						if reps
							reps = $ - 1
						else
							if state == S_PLAY_ROLL
								reps = FRACUNIT
							elseif state == S_PLAY_RUN
								state = S_PLAY_FLY
								reps = 15
							elseif state == S_PLAY_FLY
								state = S_PLAY_RUN
								reps = 5
							end 
						end
					end
					
					if state == S_PLAY_ROLL
					or state == S_PLAY_RUN
						tics = 2
					else
						tics = 3
					end
				end
				
				// draw visual
				DrawPlayer(v, x, y, FRACUNIT, player, skin, states[state].frame, frame, ANGLE_45, trans, halftrans, colormap)
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	[5] = {
		name = "Flightometer",
		command = "gauge",
		desc = "Display the flight gauge when\nflying as (or carried by) Fluffy Tails.",
		visual = function(v, x, y, player, playerval, trans, halftrans)
			local TIME = 3*TICRATE
			local skin = player.mo and player.mo.skin
			local docarry = skin and skin ~= "fluffy"
			local fluffycolor = skin ~= "fluffy" and skins["fluffy"].prefcolor or player.skincolor 
			local fluffycolormap = v.getColormap("fluffy", fluffycolor)
			local playercolor = player.skincolor
			local playercolormap = docarry and v.getColormap(skin, playercolor)
			
			local angle = ANGLE_45
			local xdist = -FixedMul(cos(angle), 4*FRACUNIT)
			local playerheight = docarry and 12*FRACUNIT + FixedDiv(skins[skin].height, FixedDiv(14*FRACUNIT, 10*FRACUNIT)) or 0
			
			local state = S_PLAY_FLY
			local tics = TIME
			local gauge = v.getSpritePatch(SPR_CHSP, B)
			
			local momz = -FRACUNIT/2
			local yoff = 0
			local ypos
			
			while true
				local drawstate
				
				if tics // continue displayed frame
					tics = $ - 1
				end
				if not tics // change frame
					state = S_PLAY_FLY_TIRED
					tics = FRACUNIT
				end
				
				yoff = $ + momz
				if state == S_PLAY_FLY_TIRED
					momz = $ + FRACUNIT/9
					if yoff > 0
						yoff = 0
						state = S_PLAY_FLY
						momz = -FRACUNIT/2
						tics = 3*TICRATE
					end
				end
				
				drawstate = state == S_PLAY_FLY and docarry and S_FLUFFY_CARRY or state
				
				// draw visual
				ypos = y + yoff
				DrawPlayer(v, x, ypos, FRACUNIT, player, "fluffy", states[drawstate].frame, A, angle, trans, halftrans, fluffycolormap)
				if docarry
					DrawPlayer(v, x + xdist, ypos + playerheight, FRACUNIT, player, skin, states[S_PLAY_RIDE].frame, A, angle, trans, halftrans, playercolormap, 2)
				end
				if playerval
					local rollangle = state == S_PLAY_FLY_TIRED and ANGLE_180 or (TIME - tics)*(INT32_MAX/TIME)
					local needle, _, offset = v.getSpritePatch(SPR_CHSP, C, 0, rollangle)
					offset = $ and 4*FRACUNIT or 0
					v.drawScaled(x, ypos, FRACUNIT, gauge, trans|V_PERPLAYER)
					v.drawScaled(x, ypos + offset, FRACUNIT, needle, trans|V_PERPLAYER)
				end
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	[6] = {
		name = "Taunt",
		command = "hater",
		desc = "Pick between the dark side or the light side.\n(Which is which is up to you.)",
		off = "Dab",
		on = "Hater",
		visual = function(v, x, y, player, playerval, trans, halftrans)
			local skin = player.mo and player.mo.skin
			local ischrispy = IsChrispySkin(skin)
			local neckinfo
			local color, colormap, posx, posy
			local count = 0
			
			local tics = 0
			local frame = -1
			
			local emotetime = 0
			local emotelife = 0
			local emotepatch
			local emotecolormap
			
			skin = ischrispy and $ or "pointy"
			neckinfo = CC_NeckSkins[skin]
			color = ischrispy and player.skincolor or skins[skin].prefcolor
			colormap = v.getColormap(skin, color)
			
			emotepatch = v.getSpritePatch(SPR_EMOT, I)
			emotecolormap = v.getColormap("pointy", color)
			
			while true
				if playerval
					local emotex = x
					local emotey = y - skins[skin].height - 14*FRACUNIT - neckinfo.emoteoffset
					
					if not tics
						tics = skins[skin].contspeed
						frame = $ + 1
						if not v.getSprite2Patch(skin, SPR2_CNT1, false, frame, 2) // out of frames? switch state
							frame = 0
						end
					end
					tics = $ - 1
					
					emotetime = ($ + 1) % TICRATE
					if emotetime < TICRATE/3
						emotex = $ + v.RandomRange(-1, 1)*FRACUNIT
						emotey = $ + v.RandomRange(-1, 1)*FRACUNIT
					end
					
					DrawPlayer(v, x, y, FRACUNIT, player, skin, SPR2_CNT1, frame, ANGLE_180, trans, halftrans, colormap)
					v.drawScaled(emotex, emotey, FRACUNIT, emotepatch, V_PERPLAYER|trans, emotecolormap)
				else
					if cv_bass.value
						count = $ + 1
						posx = x + (((count % (2*TICRATE)) ^ 2) % 5 - 2)*FRACUNIT
						posy = y + (((count % (2*TICRATE)) ^ 3) % 5 - 2)*FRACUNIT
					else
						posx = x
						posy = y
					end
					DrawPlayer(v, posx, posy, FRACUNIT, player, skin, SPR2_POSE, 0, 0, trans, halftrans, colormap)
				end
				playerval, trans, halftrans = coroutine.yield()
			end
		end
	},
	controls = "Up/Down: Cursor" +
		"\nLeft/Right: Change" +
		"\nJump: Change" +
		"\nSpin: Back"
}

local function OnChangeButton(cc, info, inc)
	local value = info.getVar(cc.player) or info.default
	local LASTBUTTON = MENUS[cc.menus[cc.layer]][cc.selections[cc.layer]].command == "menubutton" and BT_CUSTOM3 or NOBUTTON
	
	if inc < 0
		repeat
			value = $ >> 1
			if value == 0
				value = LASTBUTTON
			end
		until BUTTONNAMES[value]
	else
		repeat
			value = $ << 1
			if value > LASTBUTTON
				value = 1
			end
		until BUTTONNAMES[value]
	end
	
	return value
end
local function GetButtonName(cc, info)
	return BUTTONNAMES[info.getVar(cc.player) or info.default]
end
local BUTTONMENU = {
	name = "BUTTON SETUP",
	onenter = function(cc) CheckButtonMap(cc.player) end,
	onexit = function(cc)
		local map = cc.player.cc_buttonmap
		for action, button in pairs(map)
			for a, b in pairs(map)
				if button == b
				and a ~= action
				and button ~= NOBUTTON
					return true
				end
			end
		end
	end,
	[1] = {
		name = "Dab",
		command = "dabbutton",
		onChange = OnChangeButton,
		getOptionText = GetButtonName
	},
	[2] = {
		name = "Crouch",
		command = "crouchbutton",
		onChange = OnChangeButton,
		getOptionText = GetButtonName
	},
	[3] = {
		name = "Dance",
		command = "dancebutton",
		onChange = OnChangeButton,
		getOptionText = GetButtonName
	},
	[4] = {
		name = "Menu",
		command = "menubutton",
		onChange = OnChangeButton,
		getOptionText = GetButtonName
	},
	controls = "Up/Down: Cursor" +
		"\nLeft/Right: Change" +
		"\nJump: Change" +
		"\nSpin: Back"
}

local MAINMENU = {
	name = "MAIN MENU",
	[1] = {
		name = "Global",
		desc = "ChrispyChars settings that affect\nyou regardless of character choice.",
		menu = GLOBALMENU
	},
	[2] = {
		name = "ChrispyChars",
		desc = "Settings that only affect ChrispyChars\n(and characters using the Neck module).",
		menu = CHRISPYMENU
	},
	[3] = {
		name = "Button Setup",
		desc = "Change which buttons activate\nwhich ChrispyChars actions.",
		menu = BUTTONMENU
	},
	controls = "Up/Down: Cursor" +
		"\nJump: Select"
}

// so, apparently storing references to the menu tables in the player struct upsets netvar sending
// I guess I have to table them and store indexes instead :v
// that's why all the MENUS[cc.menus[cc.layer]] stuff exists and is annoying to read, sorry
MENUS = {MAINMENU, GLOBALMENU, CHRISPYMENU, BUTTONMENU, CONFETTIMENU}
for i = 1, #MENUS
	MENUS[i].id = i
	for j = 1, #MENUS[i]
		local option = MENUS[i][j]
		if option.menu
			for k = 1, #MENUS
				if option.menu == MENUS[k]
					option.menu = k
					break
				end
			end
		end
	end
end

local function StartMenu(cc)
	local player = cc.player
	
	cc.active = true
	cc.count = ($ or 0) % (32*6)
	cc.menus = {1} // main menu
	cc.layer = 1
	cc.selections = {1}
	cc.spread = 0
	cc.pulse = 0
	cc.transition = 0
	cc.shake = 0
	cc.changed = false
	if not splitscreen
		S_ChangeMusic("ROPTNS", true, player)
	end
end

local function KillMenu(cc)
	local player = cc.player
	local mo = player.mo
	
	cc.active = false
	for k, _ in pairs(InputTypes)
		cc[k] = INT32_MIN
	end
	player.pflags = $ | PF_JUMPDOWN | PF_USEDOWN
	if not splitscreen
		P_RestoreMusic(player)
	end
	
	if cc.changed
		CC_SaveConfiguration(player)
		S_StartSound(nil, sfx_rmenua, player)
	else
		S_StartSound(nil, sfx_rmenub, player)
	end
	
	if mo and mo.state == S_PLAY_WAIT and IsChrispySkin(mo.skin)
		mo.state = S_PLAY_STND
	end
end

local function ToggleCommand(cc, command, inc)
	local option = MENUS[cc.menus[cc.layer]][cc.selections[cc.layer]]
	local player = cc.player
	local info = commands[commandindex[command]]
	local flags = info.flags or 0
	local suffix = (not info.cvar or flags & SDF_MULTICVAR) and player == secondarydisplayplayer and "2" or ""
	local buffer = ""
	inc = $ or 1
	
	if info.cvar
		buffer = $ .. "add " .. info.name .. suffix .. " " .. inc .. ";"
	elseif flags & SDF_TOGGLE
		local playerval = info.getVar(player)
		if playerval == nil
			playerval = info.flags and info.flags & SDF_DEFAULTTRUE
		end
		buffer = $ .. info.name .. suffix .. " " .. (not playerval and 1 or 0) .. ";"
	elseif option.onChange
		buffer = $ .. info.name .. suffix .. " " .. option.onChange(cc, info, inc) .. ";"
	end
	
	SendCommand(player, buffer)
	
	S_StartSound(nil, sfx_rmenu1, player)
	cc.spread = 0
	cc.pulse = 2*FRACUNIT
	cc.changed = true
end

addHook("PreThinkFrame", do
	for player in players.iterate
		local cc = player.cc_menu
		local cmd = player.cmd
		
		if not cc
			cc = {}
			cc.active = false
			cc.interp = 0
			cc.buttontime = INT32_MIN
			cc.player = player
			for k, _ in pairs(InputTypes)
				cc[k] = INT32_MIN
			end
			
			player.cc_menu = cc
		end
		
		cc.buttontime = player.cmd.buttons & (player.cc_buttonmap and player.cc_buttonmap.menu or CC_DEFAULTBUTTONS.menu) and $ + 1 or 0
		
		if cc.buttontime == 1
			if cc.active
				local currentmenu = MENUS[cc.menus[cc.layer]]
				if currentmenu.onexit and currentmenu.onexit(cc)
					WaWah(cc)
				else
					KillMenu(cc)
				end
			elseif not player.bot
				StartMenu(cc)
			end
		end
		
		cc.interp = max(min($ + (cc.active and 1 or -1), 10), 0)
		
		if not cc.active
			continue
		end
		
		// handle inputs
		player.pflags = $ | PF_JUMPDOWN | PF_USEDOWN
		for k, v in pairs(InputTypes)
			if v(cmd, player)
				cc[k] = $ + 1
			else
				cc[k] = 0
			end
		end
		
		// if you're in the menu, disable all inputs
		cmd.forwardmove = 0
		cmd.sidemove = 0
		cmd.buttons = 0
		
		// Menu handling
		local currentmenu = MENUS[cc.menus[cc.layer]]
		
		if currentmenu.custommenu
			currentmenu.custommenu(cc)
		else
			local selectionmenu = MENUS[currentmenu[cc.selections[cc.layer]].menu]
			local selectioncommand = currentmenu[cc.selections[cc.layer]].command
			
			if cc.jump == 1
			and selectionmenu
				if selectionmenu.onenter and selectionmenu.onenter(cc)
					WaWah(cc)
				else
					cc.layer = $ + 1
					if cc.menus[cc.layer] ~= selectionmenu.id
						cc.selections[cc.layer] = 1
					end
					cc.menus[cc.layer] = selectionmenu.id
					cc.transition = $ + MENUDIST_H
					cc.spread = 0
					S_StartSound(nil, sfx_rmenua, player)
				end
			elseif cc.spin == 1 and cc.menus[cc.layer - 1]
				PreviousMenu(cc)
			elseif selectioncommand			
				if (cc.right or cc.jump) and cc.left
					// do nothing
				elseif PressOrHold(cc.right) or PressOrHold(cc.jump)
					ToggleCommand(cc, selectioncommand, 1)
				elseif PressOrHold(cc.left)
					ToggleCommand(cc, selectioncommand, -1)
				end
			end
			
			if PressOrHold(cc.up) and cc.selections[cc.layer] > 1
				cc.selections[cc.layer] = $ - 1
				cc.spread = 0
				S_StartSound(nil, sfx_rmenu1, player)
			elseif PressOrHold(cc.down) and cc.selections[cc.layer] < #MENUS[cc.menus[cc.layer]]
				cc.selections[cc.layer] = $ + 1
				cc.spread = 0
				S_StartSound(nil, sfx_rmenu1, player)
			end
		end
		
		cc.count = $ + 1
		cc.transition = FixedMul($, 3*FRACUNIT/4)
		cc.spread = $ + FixedMul(2*FRACUNIT - $, FRACUNIT/4)
		cc.pulse = FixedMul($, 3*FRACUNIT/4)
		cc.shake = max($ - 1, 0)
	end
end)

local vis_funcs = {}
local vis_threads = {}
hud.add(function(v, player)
	local cc = player.cc_menu
	
	if not (cc and cc.interp)
		return
	end
	
	local splitplayer = splitscreen and player == secondarydisplayplayer
	local trans = (10 - cc.interp) * V_10TRANS
	local halftrans = V_TRANSLUCENT + ((10 - cc.interp) >> 1) * V_10TRANS
	local crouchbutton = player.cc_buttonmap and player.cc_buttonmap.crouch or CC_DEFAULTBUTTONS.crouch
	
	split_threadnum = splitplayer and 2 or 1
	
	local function DrawVisual(option)
		if option.visual
			local playerval
			if option.command
				local info = commands[commandindex[option.command]]
				
				if info.cvar
					playerval = info.cvar.value
				elseif info.getVar
					playerval = info.getVar(player)
					if playerval == nil
					and info.flags and info.flags & SDF_TOGGLE
						playerval = info.flags & SDF_DEFAULTTRUE
					end
				end
			end
			if option.visual == vis_funcs[split_threadnum]
				local t = {coroutine.resume(vis_threads[split_threadnum], playerval, trans, halftrans)}
				if not t[1]
					print(t[2])
				end
			else
				vis_funcs[split_threadnum] = option.visual
				vis_threads[split_threadnum] = coroutine.create(vis_funcs[split_threadnum])
				coroutine.resume(vis_threads[split_threadnum], v, 280*FRACUNIT, 130*FRACUNIT, player, playerval, trans, halftrans)
			end
		else
			vis_funcs[split_threadnum] = nil
		end
	end
	
	local function DrawControls(controls)
		if controls
			local color
			if cc.crouch > 0 or crouchbutton == NOBUTTON
				local menubutton = player.cc_buttonmap and player.cc_buttonmap.menu or CC_DEFAULTBUTTONS.menu
				if menubutton ~= NOBUTTON
					controls = $ .. "\n".. BUTTONNAMES[menubutton] .. ": Save + Exit"
				end
				color = SKINCOLOR_BONE
			else
				controls = BUTTONNAMES[crouchbutton] .. ": Show controls"
				color = SKINCOLOR_GREY
			end
			DrawMenuString(v, 317*FRACUNIT, 2*FRACUNIT, FRACUNIT/2, FRACUNIT/2, controls, "RFNT", V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|trans, -1, color, true)
		end
	end
	
	// cache needed graphics
	if not valid(BLACK)
		CachePatches(v)
		vis_funcs = {}
		vis_threads = {}
	end
	
	// draw black background
	v.drawStretched(0, splitplayer and (v.height()*FRACUNIT >> 1) or 0,
		FixedDiv(v.width()*FRACUNIT, BLACK.width*FRACUNIT),
		FixedDiv(v.height()*FRACUNIT, BLACK.height*FRACUNIT << (splitscreen and 1 or 0)),
		BLACK, halftrans|V_NOSCALEPATCH)
		
	// draw zigzags
	if not splitscreen
		local height = v.height()/v.dupy()
		
		for y = -ZIGZAGSIDE.height, height, ZIGZAGSIDE.height // left
			v.draw(-51 + 32*cc.interp/10, y + (cc.count % 60), ZIGZAGSIDE, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(TC_BLINK, player.skincolor))
		end
		
		for y = 0, height + ZIGZAGSIDE.height, ZIGZAGSIDE.height // right
			v.draw(320 + 51 - 32*cc.interp/10, y - (cc.count % 60), ZIGZAGSIDE, V_SNAPTORIGHT|V_SNAPTOTOP|V_FLIP|V_PERPLAYER, v.getColormap(TC_BLINK, player.skincolor))
		end
		
		for x = -32, - 32 + 320, ZIGZAGTOP.width // top
			v.draw(x + (cc.count % 32), 16*(cc.interp - 10)/10 + ZIGZAGTOP.topoffset, ZIGZAGTOP, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(TC_RAINBOW, player.skincolor))
		end
		
		for x = 0, 320, ZIGZAGBOTTOM.width // bottom
			v.draw(x - (cc.count % 32), 201 - 16*cc.interp/10, ZIGZAGBOTTOM, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(TC_RAINBOW, player.skincolor))
		end
	end
	
	// draw menu options
	local buttontheme = BUTTONTHEMES[skincolors[splitscreen and player.skincolor or ColorOpposite(player.skincolor)].chatcolor]
	local start = 0
	local finish = 0
	if cc.transition > FRACUNIT
		start = -1
	elseif cc.transition < -FRACUNIT
		finish = 1
	end
	
	for i = start, finish
		local layer = cc.layer + i
		local menu = MENUS[cc.menus[layer]]
		
		if not menu then continue end
		
		local x = 160*FRACUNIT + cc.transition + i*MENUDIST_H + ((cc.shake + 1) % 3 - 1)*FRACUNIT
		local y = 24*FRACUNIT
		local bx = BUTTON.width*(FRACUNIT >> 1)
		local textx = x + 4*FRACUNIT
		
		DrawMenuString(v, x, y, cc.interp*FRACUNIT/10, FRACUNIT, menu.name, "RHFNT", V_PERPLAYER, 0, SKINCOLOR_BONE, false)
		
		if menu.customdraw
			if i == 0
				DrawVisual(menu)
				DrawControls(menu.controls)
			end
			menu.customdraw(v, cc, i, trans)
			return
		end
		
		x = $ - (layer ~= 1 and bx or 0)
		y = 108*FRACUNIT - MENUDIST_V * #menu / 2
		
		for j, option in ipairs(menu)
			local highlight = false
			local color = buttontheme[1]
			local spread = 0
			local sy = y + 4*FRACUNIT
			
			if j == cc.selections[layer]
				highlight = true
				color = buttontheme[2]
				spread = cc.spread
				v.drawScaled(x - bx + spread, y + spread, FRACUNIT, BUTTON, trans|V_PERPLAYER, v.getColormap(TC_DEFAULT, SKINCOLOR_CHRISP))
				
				if i == 0 // draw descriptors for current option
					DrawVisual(option)
					DrawControls(option.controls or menu.controls)
					
					if option.desc
						DrawMenuString(v, 160*FRACUNIT, (200 - 24)*FRACUNIT, 2*FRACUNIT/3, 2*FRACUNIT/3, option.desc, "RFNT", trans|V_PERPLAYER, 0, SKINCOLOR_BONE, true)
					end
				end
			end
			v.drawScaled(x - bx - spread, y - spread, FRACUNIT, BUTTON, trans|V_PERPLAYER, v.getColormap(TC_DEFAULT, color))
			DrawMenuString(v, x - spread, sy - spread, FRACUNIT, FRACUNIT, option.name, "RFNT", trans|V_PERPLAYER, 0, SKINCOLOR_BONE, true)
			
			if option.command
				local info = commands[commandindex[option.command]]
				local text
				
				if info.cvar
					text = info.cvar.string
				elseif (info.flags or 0) & SDF_TOGGLE
					local playerval = info.getVar(player)
					if playerval == nil
						playerval = info.flags and info.flags & SDF_DEFAULTTRUE
					end
					text = playerval and (option.on or "On") or (option.off or "Off")
				elseif option.getOptionText
					text = option.getOptionText(cc, info)
				end
				
				if text
					text = highlight and "< "..$.." >" or "  "..$
					DrawMenuString(v, textx, sy + (highlight and cc.pulse or 0), FRACUNIT, FRACUNIT, text, "RFNT", trans|V_PERPLAYER, 1, highlight and SKINCOLOR_SUPERGOLD5 or SKINCOLOR_BONE, true)
				end
			end
			y = $ + MENUDIST_V
		end
	end
end, "game")