/*
ChrispyChars SRB2P stat cloner
	by Lach

beta
*/

if not srb2p return end

// Followmobj hacks

local function valid(mo)
	return mo and mo.valid
end

local function PointySRB2P(mo)
	if not valid(mo) return end
	
	local target = mo.target
	local player = valid(target) and target.control
	
	if player
		target.frame = $ + 1
		CC_PointyOverball(player, mo, target)
		P_TeleportMove(mo,
			target.x + target.momx,
			target.y + target.momy,
			target.z + target.momz)
		target.frame = $ - 1
	end
end

local function FluffySRB2P(mo)
	if not valid(mo) return end
	
	local target = mo.target
	local player = valid(target) and target.control
	
	if player
		P_TeleportMove(target,
			target.x + target.momx,
			target.y + target.momy,
			target.z + target.momz)
		CC_TailsThinker(player, target)
		P_TeleportMove(target,
			target.x - target.momx,
			target.y - target.momy,
			target.z - target.momz)
	end
end

// character stats	

local BASESKINS = {"sonic", "tails"} // skins to copy stats from
local SKINS = {"pointy", "fluffy"}

local NEWSTATS = {
	pointy = {
		overlay = MT_POINTY_OVERBALL,
		overlaythink = PointySRB2P,
		
		supercolor_start = SKINCOLOR_SUPERLIGHTBULB1,
		
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_LAND"},
		anim_atk =			{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, 1, "SPR2_ROLL"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, 1, "SPR2_ROLL"},	-- jumping out of all-out attack
		anim_revive =		{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, 1, "SPR2_ROLL"},	-- gets revived
		anim_getup =		{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, 1, "SPR2_ROLL"},	-- gets up from down
		anim_evoker =		{SPR_PLAY, A, 2, "SPR2_POSE"},	-- holding evoker to head
		anim_evoker_shoot =	{SPR_CSMN, A, 2, "SPR2_POSE"},	-- shooting evoker
		
		anim_stand_super = 			{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_stand_hurt_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_stand_bored_super = 	{SPR_PLAY, A, 4, "SPR2_STND"},		-- standing
		anim_run_super = 			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- run
		anim_evoker_super = 		{SPR_PLAY, A, 4, "SPR2_POSE"},
		anim_evoker_shoot_super = 	{SPR_PLAY, A, 4, "SPR2_POSE"},
		
		icon = "ICO_SONI",	-- icon for net select and other menus
		hudbust = "POINTY_H",			-- patch to draw on the stat hud
		hudaoa = "AOA_POINTY",	-- patch for all out attack hud
		hudsbust = "POINTY_H",
		hudsaoa = "AOA_POINTY",	-- same but for supers
		aoa_quote = "Time to dab\non the haters!",
	},
	fluffy = {
		overlaythink = FluffySRB2P,
		
		supercolor_start = SKINCOLOR_SUPERSTREETLAMP1,
		
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_LAND"},
		anim_run = 			{SPR_PLAY, A, B, C, 2, "SPR2_RUN_"},
		anim_atk =			{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},	-- jumping out of all-out attack
		anim_revive =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},	-- gets revived
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},	-- gets up from down
		anim_evoker =		{SPR_PLAY, A, 2, "SPR2_POSE"},	-- holding evoker to head
		anim_evoker_shoot =	{SPR_CSMN, A, 2, "SPR2_POSE"},	-- shooting evoker
		
		anim_special1 = 	{SPR_PLAY, A, 2, "SPR2_FLY"},	-- special animations, 32 slots // (I know this is the same for vanilla Tails, but I'm taking precaution in case the second fly frame is patched in)
		
		icon = "ICO_TAIL",	-- icon for net select and other menus
		hudbust = "FLUFFY_H",			-- patch to draw on the stat hud
		hudaoa = "AOA_FLUFFY",	-- patch for all out attack hud
		aoa_quote = "I'll yeet you\ninto oblivion!",
	}
}

// apply all stats from base skins to added skins, then overwrite stats with all changed stats

for i, skin in ipairs(SKINS)
	local baseskin = BASESKINS[i]
	
	DNG_Abilities[skin] = DNG_Abilities[baseskin]
	
	charStats[skin] = {}
	
	for k, v in pairs(charStats[baseskin])
		charStats[skin][k] = v
	end
	
	if NEWSTATS[skin]
		for k, v in pairs(NEWSTATS[skin])
			charStats[skin][k] = v
		end
	end
end

// extra tweaks

DNG_Abilities["pointy"] = {
	jfunc = CC_MomentumFlip,
	func = nil
}